package wclient;

import java.io.*;
import java.net.*;
import javax.swing.UIManager;

/**
This Class is responsible for all the communications setup on the
client-side between the client and server.
*/


public class Communicator
{
 private boolean packFrame = false;
 private ObjectOutputStream out;
         ObjectInputStream in;
 private Socket clientSocket;
 int i;
 private String hn; //hostname
 private int pn;    //portnum

 public Communicator(String hostname, int portnum)
 {
  hn = hostname;
  pn = portnum;
 }

 public Communicator()
   {

   }

 public void createConnection()
 {
   try
   {
    System.out.println("Attempting to connect to server at " + hn
		       + ", port " + pn + "...");
    clientSocket = new Socket(hn, pn);
     //clientSocket = new Socket("localhost", 10000);
    out = new ObjectOutputStream(clientSocket.getOutputStream());
    in = new ObjectInputStream(clientSocket.getInputStream());
    System.out.println("   connection successful.");
   }

   catch(UnknownHostException uhe)
   {
     System.err.println("Unknown host " + hn + " when creating connection.");
     uhe.printStackTrace();
     System.exit(1);
   }

   catch(IOException ioe)
   {
     System.err.println("Encountered ioexception in client.");
     ioe.printStackTrace();
     System.exit(1);
   }

  }

  public boolean checkAvailability()
  {
   boolean available = true;
   try
   {

    if(in.available() > 0)
     available = true;
    else
    {
     available = false;
    }
    }
   catch(IOException e)
   {
    System.out.println("Communicator: Error in reading from stream.");
   }
   return available;
  }
  public void writeInformation(Object s) throws IOException
  {
    try
    {
      System.out.println("client: writing the following object output stream: " + s);
      out.writeObject(s);
      out.flush();
    }
    finally
    {
    }
  }

  public ObjectInputStream getInputStream()
  {
    return in;
  }

  public void writeInt(int i) throws IOException
  {
    try
    {
      System.out.println("client: writing the int to output stream: " + i);
      out.writeInt(i);
      out.flush();
    }
    finally
    {
    }
  }


  public int readIntFromStream()
  {
    try
    {
      i = in.readInt();
    }
    catch (IOException e)
    {
      System.out.println("IOException in reading integer");
    }
    return i;
  }

  public Object readInformation()
  {
   try
     {
      Object obj = new Object();
      obj = in.readObject();
      return obj;
     }
   catch(ClassNotFoundException cne)
    {
    System.out.println("Client Communicator: Class not found");
    }
   catch(IOException ioe)
   {
    System.out.println("Client Communicator: IOException");
   }
    System.out.println("Returning alias in readINfo");
    Object obj1 = new Object();
    return obj1;
  }
}


