
//Title:        wclient
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Kruti Mehta
//Company:      UTA
//Description:  Research Assistant

package wclient;

import java.awt.*;
import javax.swing.JFrame;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.JFrame;
import java.util.*;
import java.awt.image.*;
import wAction.Action;
import wPercept.TransferPercept;

/**
Frame Displaying the normal percepts and the natural language hint.
*/

public class Frame1 extends JFrame
{
   MenuBar mbar;
   CheckboxMenuItem displayImage;
   CheckboxMenuItem displayPercept;
   CheckboxMenuItem displayHint;
   CheckboxMenuItem displayStatus;

   TextField stenchText = new TextField();
   TextField breezeText = new TextField();
   TextField glitterText = new TextField();
   TextField bumpText = new TextField();
   TextField screamText = new TextField();
   TextField hintText = new TextField();
   TextField lastActionText = new TextField();
   TextField agentStatusText = new TextField();
   TextField scoreText = new TextField();
   TextField arrowText = new TextField();
   TextField goldPiecesText = new TextField();

   Panel panel0 = new Panel();
   Panel panel1 = new Panel();
   Panel panel2 = new Panel();

   public Frame1()
   {

    this.getContentPane().setSize(200,400);
    setArea();
   }

   public void setArea()
   {
    this.getContentPane().setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = 1;
    gbc.gridy = 1;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1;
    gbc.weighty = 0.45;
    setPerceptPanel();
    this.getContentPane().add(panel0,gbc);
    gbc.gridy = 2;
    gbc.weighty = 0.1;
    setHintPanel();
    this.getContentPane().add(panel1,gbc);
    gbc.gridy = 3;
    gbc.weighty = 0.45;
    setStatusPanel();
    this.getContentPane().add(panel2,gbc);
   }

   public void setPerceptPanel()
   {
    panel0.setLayout(new GridBagLayout());
    GridBagConstraints gbc0 = new GridBagConstraints();
    gbc0.fill = GridBagConstraints.BOTH;
    gbc0.insets = new Insets(10,0,10,0);
    gbc0.gridwidth = 4;
    gbc0.gridheight = 1;
    gbc0.gridx = 1;
    gbc0.gridy = 1;
    gbc0.weightx = 1;
    gbc0.weighty = 0.05;
    JButton jb0 = new JButton();
    jb0.setText("PERCEPT INFORMATION");
    jb0.disable();
    panel0.add(jb0, gbc0);

    gbc0.insets = new Insets(5,5,5,15);
    gbc0.gridwidth = 1;
    gbc0.gridheight = 1;
    gbc0.gridx = 1;
    gbc0.gridy = 2;
    gbc0.weighty = 0.1;
    gbc0.weightx = 0.2;

    panel0.add(new Label("Stench: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 2;
    gbc0.weightx = 0.3;
    panel0.add(stenchText,gbc0);
    gbc0.gridx = 3;
    gbc0.gridy = 2;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Breeze: ",Label.RIGHT),gbc0);
    gbc0.gridx = 4;
    gbc0.gridy = 2;
    gbc0.weightx = 0.3;
    panel0.add(breezeText,gbc0);
    gbc0.gridx = 1;
    gbc0.gridy = 3;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Glitter: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 3;
    gbc0.weightx = 0.3;
    panel0.add(glitterText,gbc0);
    gbc0.gridx = 3;
    gbc0.gridy = 3;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Bump: ",Label.RIGHT),gbc0);
    gbc0.gridx = 4;
    gbc0.gridy = 3;
    gbc0.weightx = 0.3;
    panel0.add(bumpText,gbc0);
    gbc0.gridx = 1;
    gbc0.gridy = 4;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Scream: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 4;
    gbc0.weightx = 0.3;
    panel0.add(screamText,gbc0);
   }

   public void setHintPanel()
   {

    panel1.setLayout(new GridBagLayout());
    GridBagConstraints gbc1 = new GridBagConstraints();
    gbc1.fill = GridBagConstraints.BOTH;
    gbc1.insets = new Insets(10,0,10,0);
    gbc1.gridx = 1;
    gbc1.gridy = 1;
    gbc1.gridheight = 1;
    gbc1.gridwidth = 2;
    gbc1.weightx = 1.0;
    gbc1.weighty = 0.08;
    panel1.add(new JButton("NATURAL LANGUAGE HINT"),gbc1);
    gbc1.insets = new Insets(5,5,5,15);
    gbc1.gridheight = 1;
    gbc1.gridwidth = 1;
    gbc1.gridx = 1;
    gbc1.gridy = 2;
    gbc1.weighty = 0.95;
    gbc1.weightx = 0.01;
    panel1.add(new Label("Hint: ",Label.RIGHT),gbc1);
    gbc1.gridx = 2;
    gbc1.gridy = 2;
    gbc1.weightx = 0.99;
    panel1.add(hintText,gbc1);
   }

   public void setStatusPanel()
   {

    panel2.setLayout(new GridBagLayout());
    GridBagConstraints gbc2 = new GridBagConstraints();
    gbc2.fill = GridBagConstraints.BOTH;
    gbc2.gridx = 1;
    gbc2.gridy = 1;
    gbc2.gridheight = 1;
    gbc2.gridwidth = 4;
    gbc2.weightx = 1.0;
    gbc2.weighty = 0.05;
    gbc2.insets = new Insets(10,0,10,0);
    panel2.add(new JButton("STATUS INFORMATION"),gbc2);

    gbc2.insets = new Insets(5,5,5,15);
    gbc2.gridheight = 1;
    gbc2.gridwidth = 1;


    gbc2.gridx = 1;
    gbc2.gridy = 2;

    gbc2.weighty = 0.1;
    gbc2.weightx = 0.2;

    panel2.add(new Label("Last Action: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 2;
    gbc2.weightx = 0.3;
    panel2.add(lastActionText,gbc2);
    gbc2.gridx = 3;
    gbc2.gridy = 2;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Agent State: ",Label.RIGHT),gbc2);
    gbc2.gridx = 4;
    gbc2.gridy = 2;
    gbc2.weightx = 0.3;
    panel2.add(agentStatusText,gbc2);
    gbc2.gridx = 1;
    gbc2.gridy = 3;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Score: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 3;
    gbc2.weightx = 0.3;
    panel2.add(scoreText,gbc2);
    gbc2.gridx = 3;
    gbc2.gridy = 3;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Arrows: ",Label.RIGHT),gbc2);
    gbc2.gridx = 4;
    gbc2.gridy = 3;
    gbc2.weightx = 0.3;
    panel2.add(arrowText,gbc2);
    gbc2.gridx = 1;
    gbc2.gridy = 4;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Gold Pieces: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 4;
    gbc2.weightx = 0.3;
    panel2.add(goldPiecesText,gbc2);
   }

   public void setMenu()
   {
    MenuBar mbar = new MenuBar();
    Menu displayMenu = new Menu("Display", true);

    displayMenu.add(displayImage = new CheckboxMenuItem("Image"));
    displayMenu.add(displayPercept = new CheckboxMenuItem("Percepts"));
    displayMenu.add(displayHint = new CheckboxMenuItem("Hint"));
    displayMenu.add(displayStatus = new CheckboxMenuItem("Status"));

    displayImage.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Image status is " + displayImage.getState());
     }
    });
    displayPercept.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Percepts status is " + displayPercept.getState());
     }
    });
    displayHint.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Hint status is " + displayHint.getState());
     }
    });
    displayStatus.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Status status is " + displayStatus.getState());
     }
    });

    mbar.add(displayMenu);
    setMenuBar(mbar);

   } 

   public void setStenchText(String s)
   {
    stenchText.setText(s);
   }

   public void setBreezeText(String s)
   {
    breezeText.setText(s);
   }

   public void setGlitterText(String s)
   {
    glitterText.setText(s);
   }

   public void setBumpText(String s)
   {
    bumpText.setText(s);
   }

   public void setScreamText(String s)
   {
    screamText.setText(s);
   }

   public void setHintText(String s)
   {
    hintText.setText(s);
   }

   public void setLastActionText(String s)
   {
    lastActionText.setText(s);
   }

   public void setAgentStatusText(String s)
   {
    agentStatusText.setText(s);
   }

   public void setScoreText(String s)
   {
    scoreText.setText(s);
   }

   public void setArrowText(String s)
   {
    arrowText.setText(s);
   }

   public void setGoldPiecesText(String s)
   {
    goldPiecesText.setText(s);
   }

   public void updateDisplay(TransferPercept tp)
   {
    Action acted = new Action();
    setLastActionText(acted.printAction(tp.getActionTaken()));
    setAgentStatusText(String.valueOf(tp.getStatus()));
    setScoreText(String.valueOf(tp.getScore()));
    setArrowText(String.valueOf(tp.getNumArrow()));
    setGoldPiecesText(String.valueOf(tp.getNumGold()));
    setStenchText(String.valueOf(tp.getStench()));
    setBreezeText(String.valueOf(tp.getBreeze()));
    setGlitterText(String.valueOf(tp.getGlitter()));
    setBumpText(String.valueOf(tp.getBump()));
    setScreamText(String.valueOf(tp.getScream()));
    setHintText(tp.getHint());
   }
}
