package wclient;

import java.awt.*;
import javax.swing.JFrame;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.JFrame;
import java.util.*;
import java.awt.image.*;
import wPercept.TransferPercept;

/**
Window displaying the Image Percepts of the agent.
*/

public class Frame2 extends Frame
{
   Image img;

   public Frame2()
   {
    this.setTitle("Image Percept");
   }

   public Image makeImage(TransferPercept tp)
   {
    Image image;
    int height = tp.getImageHeight();
    int width = tp.getImageWidth();
    int[][][] pixels = tp.getImagePixels();
    int[] pixdata = new int[height*width];


    int k = 0;
    for(int i = 0; i<height; ++i)
     for(int j = 0; j<width; ++j)
     {
      int alpha = 255;
      int red = pixels[i][j][0];
      int green = pixels[i][j][1];
      int blue = pixels[i][j][2];
      pixdata[k++] = (alpha <<24)|(red<<16)|(green<<8) | blue;
     }
    System.out.println("Making Image.......");
    image = createImage(new MemoryImageSource(width, height, pixdata, 0, width));
    setImage(image);
    this.paintImage();
    return image;

   }

   public void setImage(Image pict)
   {
    img = pict;
   }

   public void paint(Graphics g)
   {
    super.paint(g);
    if(img != null)
     g.drawImage(img, 50,50,64,64,this);
   }

   public void paintImage()
   {
    repaint();
   }


}