package wclient;
import java.io.*;
import java.net.*;
import javax.swing.UIManager;
import wPercept.TransferPercept;
import wAction.Action;

/**
This class is responsible for the working of the client.
It calls the player's process function and passes the
transferpercept object to the process function. It gets
action back from the client and sends it to the server for
execution.
*/


public class GameClient
{

 Frame1 frame;
 Frame2 frame2;

  public GameClient()
  {
    boolean packFrame = false;
    frame = new Frame1();
    frame2 = new Frame2();
    frame2.setVisible(true);
    frame.setVisible(true);
    frame.setSize(500, 400);
    frame2.setSize(200,300);
    frame.show();
    frame2.show();
  }

  //Main method
  public static void main(String[] args)
   {
    TransferPercept tp = new TransferPercept();
    try
    {
      boolean simulationEnd = false;
      GameClient gc = new GameClient();
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      String s = "";

      String hostname = "localhost";
      int portnum = 10000;

      for(int i = 0; i < args.length; ++i)
      {
       if (args[i].equals("-h"))
         hostname = args[i+1];
       else if(args[i].equals("-p"))
         portnum = Integer.parseInt(args[i+1]);
      }

      Communicator clientcomm = new Communicator(hostname, portnum);

      //Communicator clientcomm = new Communicator();
      clientcomm.createConnection();
      System.out.println("created iostreams..");
      int id = clientcomm.readIntFromStream();
      System.out.println("Instantiating Player : " + id);
      gc.frame.setTitle("Percepts & Status for AGENT: " + id);
      Player MyPlayer = new Player(id, clientcomm);

      PerceptKeeper keeper = new PerceptKeeper(clientcomm);
      keeper.start();
      while(simulationEnd == false)
      {
        while(keeper.vecPercepts.isEmpty())
        {}

        tp = (TransferPercept)keeper.vecPercepts.firstElement();
        keeper.vecPercepts.removeElement(tp);
        if(tp.getActionTaken() != Action.END_SIMULATION)
        {
         int action = MyPlayer.process(tp, gc.frame, gc.frame2);
         if(tp.getActionTaken() != Action.END_TRIAL)
          clientcomm.writeInt(action);
         else
          MyPlayer.resetCounter(0);
        }
        else
        {
         simulationEnd = true;
         gc.frame.dispose();
         gc.frame2.dispose();
        }
      }
    }
    catch(Exception e)
    {
     e.printStackTrace();
      System.out.println("GameClient: There was an exception");
    }
    System.out.println();
    System.out.println("------------- Game End Statistics ------------");
    System.out.println("Average Score: " + tp.getAverageScore());
    System.out.println("Standard Deviation: " + tp.getStdDeviation());
    System.out.println("-----------------------------------------------");

  }//end main
}

