package wclient;

import java.util.Vector;
import wPercept.TransferPercept;
import java.net.*;
import java.io.*;

/**
Responsible for keeping any transferpercept objects that may
appear on the socket, so that they may be accessed by the
agent at any time.
*/


public class PerceptKeeper extends Thread
{
  private Communicator perceptcomm;
  private ObjectInputStream inpstream;
  Vector vecPercepts;

  public PerceptKeeper(Communicator comm)
  {
    vecPercepts = new Vector();
    perceptcomm = comm;
  }

  public void run()
  {
  while(true)
    {
//      System.out.println("READING IN PERCEPT KEEPER");
      TransferPercept trans = new TransferPercept();

      try{
      trans = (TransferPercept)perceptcomm.readInformation();
      }
      // We can't get a new percept; Game Over.
      catch (ClassCastException e){
          System.exit(0);
      }
      vecPercepts.add(trans);
//      System.out.println("END.");
      try{
      sleep(2000);}

      catch(InterruptedException ie)
      {
        System.out.println(" Thread disturbed while sleeping");
      }
    }
  }

}
