package wclient;

import java.net.*;
import wInput.InputTaker;
import wAction.Action;
import wPercept.TransferPercept;
import java.awt.*;

public class Player
{
  int agentID;
  Communicator pipe;
  private static int stepcounter = 0;
  int[] s;


  public Player(int id, Communicator comm)
  {
    agentID = id;
    System.out.println("I am Player Number " + agentID);
    pipe = comm;

    if(id ==0)
    {
      s = new int[21];
      s[0] = Action.GOFORWARD;
      s[1] = Action.TURN_LEFT;
      s[2] = Action.GOFORWARD;
      s[3] = Action.TURN_RIGHT;
      s[4] = Action.GOFORWARD;
      s[5] = Action.GOFORWARD;
      s[6] = Action.GOFORWARD;
      s[7] = Action.TURN_LEFT;
      s[8] = Action.SHOOT;
      s[9] = Action.GOFORWARD;
      s[10] = Action.GRAB;
      s[11] = Action.TURN_LEFT;
      s[12] = Action.GOFORWARD;
      s[13] = Action.GOFORWARD;
      s[14] = Action.GOFORWARD;
      s[15] = Action.TURN_LEFT;
      s[16] = Action.GOFORWARD;
      s[17] = Action.GOFORWARD;
      s[18] = Action.TURN_RIGHT;
      s[19] = Action.GOFORWARD;
      s[20] = Action.CLIMB;
    }

    else if(id ==1)
    {
      s = new int[23];
      s[0] = Action.GOFORWARD;
      s[1] = Action.TURN_LEFT;
      s[2] = Action.GOFORWARD;
      s[3] = Action.GOFORWARD;
      s[4] = Action.GOFORWARD;
      s[5] = Action.TURN_RIGHT;
      s[6] = Action.GOFORWARD;
      s[7] = Action.GOFORWARD;
      s[8] = Action.SHOOT;
      s[9] = Action.GOFORWARD;
      s[10] = Action.GRAB;
      s[11] = Action.TURN_LEFT;
      s[12] = Action.TURN_LEFT;
      s[13] = Action.GOFORWARD;
      s[14] = Action.GOFORWARD;
      s[15] = Action.GOFORWARD;
      s[16] = Action.TURN_LEFT;
      s[17] = Action.GOFORWARD;
      s[18] = Action.GOFORWARD;
      s[19] = Action.GOFORWARD;
      s[20] = Action.TURN_RIGHT;
      s[21] = Action.GOFORWARD;
      s[22] = Action.CLIMB;
    }


  }

  public int process(TransferPercept tp, Frame1 frame, Frame2 frame2)
  {
    // Instructions for Intelligent Agents Design
    // Do not Remove Section I code if want to display GUI and scores
    // Section I Start
    pipe.checkAvailability();
    this.statusDisplay(tp);
    frame.updateDisplay(tp);
    frame2.makeImage(tp);

    // Section I End.

    // Start of the code for the Intelligent Agent.
    // The sample code is for manual agent.

    if(tp.getStatus() != 1 && tp.getActionTaken() != Action.END_TRIAL)
    {
      return Action.NO_ACTION;
    }
    else
    {
     if(tp.getActionTaken() != Action.END_TRIAL)
     {
      int myaction = stackPlay();
      return myaction;
     }
     else
     {
      int myaction = Action.NO_ACTION;
      return myaction;
      }
    }
  }

  public int stackPlay()
  {

    this.stepcounter++;

    return s[stepcounter -1];
  }







  public int manualPlay()
  {
    InputTaker myreader = new InputTaker();
    String s = "";
    s = myreader.readLine("Enter an action command: ");

    if(s.equals("f"))
      return Action.GOFORWARD;
    else if(s.equals("l"))
      return Action.TURN_LEFT;
    else if(s.equals("r"))
      return Action.TURN_RIGHT;
    else if(s.equals("t"))
      return Action.SIT;
    else if(s.equals("g"))
      return Action.GRAB;
    else if(s.equals("s"))
      return Action.SHOOT;
    else if(s.equals("c"))
      return Action.CLIMB;
    else
      return -1;
  }

  public void statusDisplay(TransferPercept tp)
  {
    Action acted = new Action();
    System.out.println("____________________________________________");
    System.out.println(" STATUS INFORMATION");
    System.out.println("____________________________________________");
    System.out.println("Last Action Executed: " + acted.printAction(tp.getActionTaken()));
    System.out.println("My Status is: " + tp.getStatus());
    System.out.println("My Score is: " + tp.getScore());
    System.out.println("Arrows: " + tp.getNumArrow());
    System.out.println("Gold Pieces: " + tp.getNumGold());
    System.out.println("");
    System.out.println("____________________________________________");
    System.out.println(" PERCEPT INFORMATION");
    System.out.println("____________________________________________");
    System.out.println("Stench: " + tp.getStench());
    System.out.println("Breeze: " + tp.getBreeze());
    System.out.println("Glitter: " + tp.getGlitter());
    System.out.println("Bump: " + tp.getBump());
    System.out.println("Scream: " + tp.getScream());
    System.out.println("____________________________________________");
    System.out.println("HINT INFORMATION");
    System.out.println("hint: " + tp.getHint());
    System.out.println("____________________________________________");
  }

  public void resetCounter(int a)
  {
   stepcounter = a;
  }

}
