package wworld;

/**
   An Actor is either an agent or a wumpus. They have different states
   which are described by the ActorState class.

   @author Kruti Mehta
*/

public class ActorState
{
   /** Describes the state of the actor when the actor is alive in the world. */
   public static final int ALIVE = 1;

   /** Describes the state of the actor when the actor is dead in the world. */
   public static final int DEAD = 2;

   /** Describes the state of the agent when the agent has climbed out of
   the cave alive. */
   public static final int VICTORIOUS = 3;

   private int actorState;

   /**
   Constructor for ActorState with setting of initial state of the Actor
   @param actorState as integer
   */
   public ActorState(int a)
   {
    actorState = a;
   }

   /**
   Returns the State of the Actor.
   @return State of the actor.
   */
   public int getActorState()
   {
    return actorState;
   }

   /**
   Returns the State of the Actor.
   @param actorState as integer.
   */
   public void setActorState(int a)
   {
     actorState = a;
   }

   /**
   Returns the state of the actor as a string alive, dead or victorious
   @return alive, dead or victorious
   */
   public String toString()
   {
    String s = new String();
    if(actorState == ALIVE) s = "alive";
    else if(actorState == DEAD) s = "dead";
    else if(actorState == VICTORIOUS) s = "victorious";

    return s;
   }

}