package wworld;

/**
    This class is used to describe the directions in which the moving
    objects in the World can face.
    @author Kruti Mehta
*/
public class Directions
{
   public static final int RIGHT = 1;
   public static final int UP = 2;
   public static final int LEFT = 3;
   public static final int DOWN = 4;

   private int facing;

   /**
   Constructor for the facing or directions
   @param Direction that the moving object is initially facing.
   */
   public Directions(int lookingTo)
   {
    facing = lookingTo;
   }

   /**
   Returns the direction that is represented by the object.
   @return object facing or direction as integer.
   */
   public int getFacing()
   {
    return facing;
   }

   /**
   Used to set the facing represented by this object.
   @param facing of the object as integer.
   */
   public void setFacing(int i)
   {
    facing = i;
   }

   /**
   Returns the direction or facing of the object as String.
   @return facing of the object - left, right, up or down as String.
   */
   public String toString()
   {
    String s = new String();
    if(facing == LEFT) s = "left";
    else if(facing ==RIGHT) s = "right";
    else if(facing ==UP) s = "up";
    else if(facing ==DOWN) s = "down";

    return s;
   }

}