package wworld;

/**
   Class specifying gridobject. The object gridObject extends worldObject
   and contains information of the location and original location where
   it resided at the start of the game.
   @author Kruti Mehta
*/
public class GridObject extends WorldObject
{
   /** Current location of the object */
   private GridPoint location;
   /** Location of the object at the start of the game. */
   private GridPoint origLocation;

   /** Constructor with setting of object type, location and original location */
   public GridObject(int objType, int someX, int someY)
   {
     super(objType);
     location =  new GridPoint(someX, someY);
     origLocation = new GridPoint(someX, someY);
   }

   /**
   Returns original location of the gridObject
   */
   public GridPoint getOrigLocation()
   {
    return origLocation;
   }

   /**
   Returns the current location of the gridObject
   */
   public GridPoint getLocation()
   {
    return location;
   }

   /**
   Sets the location of the gridObject to the gridpoint specified.
   */
   public void setLocation(GridPoint p)
   {
    location = (GridPoint)p.clone();
   }

   /**
   Sets the location of the gridObject to the location (x,y) specified.
   */
   public void setLocation(int x, int y)
   {
    GridPoint gp = new GridPoint(x , y);
    setLocation(gp);
   }

}