package wworld;

/**
   This class describes the kinds of objects that can reside
   in the wumpus world.
   @author Kruti Mehta
*/
public class GridObjectType
{
   public static final int WUMPUS = 1;
   public static final int PIT = 2;
   public static final int GOLD = 3;
   public static final int OBSTACLE = 4;
   public static final int WALL = 5;
   public static final int AGENT = 6;
   private int objectOfType;

   public GridObjectType(int type)
   {
    objectOfType = type;
   }

   public int getObjectType()
   {
    return objectOfType;
   }

   /**
   Returns an String according to the type of the object.
   @return wumpus, pit, gold, obstacle, wall or agent string.
   */
   public String toString()
   {
    String s = new String();

    if(objectOfType == WUMPUS) s = "wumpus";
    else if (objectOfType == PIT) s = "pit";
    else if (objectOfType == GOLD) s = "gold";
    else if (objectOfType == OBSTACLE) s = "obstacle";
    else if (objectOfType == WALL)  s = "wall";
    else if (objectOfType == AGENT) s = "agent";
    return s;
   }

}