package wworld;

/**
Keeps track of the score statistics for each agent.
*/
public class ScoreKeeper
{
  private int noOfTrials;
  int[] gameScore;
  double averageScore;
  double stdDeviation;

  /**
  Constructor. Initializes score information.
  */
  public ScoreKeeper(int numTrials)
  {
    noOfTrials = numTrials;
    gameScore = new int[noOfTrials + 1];
    for(int i = 0; i <= noOfTrials; ++i)
      gameScore[i] = 0;
  }

  /**
  Calculates average score for the completed trials.
  */
  public void calculateAvgScore()
  {
    int total = 0;
    for(int i = 1; i <= noOfTrials; ++i)
    {
      System.out.println("gameScore for trial " + i + " is " + gameScore[i]);
      total += gameScore[i];
    }
    averageScore = (double) ((total*1.0)/(noOfTrials*1.0));
  }

  /**
  Calculates scores standard deviation for the completed trials.
  */

  public void calculateStdDeviation()
  {
   double sum = 0;
   for(int i = 1; i <=noOfTrials; ++i)
    sum = sum + (gameScore[i]-averageScore) * (gameScore[i]-averageScore);
   sum = sum / noOfTrials;
   stdDeviation = Math.sqrt(sum);
  }

  public double getAverageScore()
  {
   return averageScore;
  }

  public double getStdDeviation()
  {
   return stdDeviation;
  }

}